# bulkImport.py - imports all email files of all users in one step
#
# Copyright (c) 2012,2013 MailStore Software GmbH
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#modify this according to your installation
#create a schedule of a profile and hit "Copy Cmd Line"
#paste the clipboard into notepad to get the values needed here
#REM *** templateBulkImportPST (ID 73) ***
#"C:\Program Files (x86)\deepinvent\MailStore Server\MailStoreCmd.exe" --h="127.0.0.1:8460" --pkv3="cd:38:e4:f9:89:b1:db:49" --u="admin" --pc="RrlCfpFB9YJt+QKPGLBhw0hp" --o="C:\ProgramData\MailStore\TaskLog\73_{DATE}-{TIME}.log" -c import-execute --id=73 --user="admin" --verbose
MAILSTORECMD = r"C:\Program Files (x86)\deepinvent\MailStore Server\MailStoreCmdSilent.exe"
HOST = "127.0.0.1:8460"
PKV3 = "cd:38:e4:f9:89:b1:db:49" 
USER = "admin"
PASS = "RrlCfpFB9YJt+QKPGLBhw0hp"

#location of the folders containing the user's pst/emlmsg/mbox files
#has to be the same as in createUserFolders.py
rootpath=r"c:\mailstoreimport"

#which bulk import do you want to start? pst, emlmsg or mbox?
filetype="pst"

################### DON'T CHANGE ANYTHING BELOW THIS LINE ###################
import subprocess, os, shlex

def executeCommand(cmd):
    command = "\"" + MAILSTORECMD + "\"" + " --h=\"" + HOST + "\" --u=\"" + USER + "\" --pc=\"" + PASS + "\" --pkv3=\"" + PKV3 + "\" --nologo" + " --verbose" + cmd
    try:
        output = subprocess.check_call(shlex.split(command))
    except subprocess.CalledProcessError as e:
        print(" exitcode: {0}".format(e.returncode))
        print("output    : {0}".format(e.output))
        print("command   : {0}".format(command))
    else:
        print(" exitcode: {0}".format(output))

def bulkImport():
    for username in os.listdir(rootpath):
        userpath = os.path.join(rootpath, username)   
        if os.path.isdir(userpath):
            print("USER {0}".format(username))
            if filetype == "emlmsg":
                executeCommand(" --o=\"" +os.path.join(rootpath,"{DATE}-{TIME}-"+username+".log") + "\"" \
                                " -c import-execute" + \
                                " --name=\"templateBulkImportEMLMSG\"" + \
                                " --[directory]=\"" + userpath + "\""\
                                " --[recurse]=1" \
                                " --[readXMailStoreHeaders]=0" + \
                                " --[targetUserFolder]=\"" + username + "\"")
            elif filetype == "pst":
                for file in os.listdir(userpath):
                    filepath = os.path.join(userpath, file)
                    if filepath.lower().endswith(".pst"):
                        print("FILE {0}".format(filepath),end='')
                        executeCommand(" --o=\"" +os.path.join(rootpath,"{DATE}-{TIME}-"+username+"-"+os.path.basename(filepath)+".log") + "\"" \
                                        " -c import-execute" + \
                                        " --name=\"templateBulkImportPST\"" + \
                                        " --[targetUserFolder]=\"" + username + "\"" + \
                                        " --[outlookProfile]=\"" + filepath + "\"")
            elif filetype == "mbox":
                for file in os.listdir(userpath):
                    filepath = os.path.join(userpath, file)
                    print("FILE {0}".format(filepath),end='')
                    executeCommand(" --o=\"" +os.path.join(rootpath,"{DATE}-{TIME}-"+username+"-"+os.path.basename(filepath)+".log") + "\"" \
                                    " -c import-execute" + \
                                    " --name=\"templateBulkImportMBOX\"" + \
                                    " --[targetUserFolder]=\"" + username + "\"" + \
                                    " --[path]=\"" + filepath + "\"")
            else:
                print("ERROR: filetype not valid. Should be pst, emlmsg or mbox, but is \"{0}\"".format(filetype))

bulkImport()
print("done")
